<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', '../');
require PUN_ROOT.'include/common.php';
require PUN_ROOT.'include/common_admin.php';


if (!$pun_user['is_admmod'])
	message($lang_common['No permission']);

// Load the admin.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/admin.php';


// Zap a report
if (isset($_POST['zap_id']))
{
	$zap_id = intval(key($_POST['zap_id']));

	$result = $db->query('SELECT zapped FROM '.$db->prefix.'reports WHERE id='.$zap_id) or error('Unable to fetch report info', __FILE__, __LINE__, $db->error());
	$zapped = $db->result($result);

	if ($zapped == '')
		$db->query('UPDATE '.$db->prefix.'reports SET zapped='.time().', zapped_by='.$pun_user['id'].' WHERE id='.$zap_id) or error('Unable to zap report', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['admin_reports']), $lang_admin['Report marked as read'].' '.$lang_admin['Redirect']);
}


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($lang_admin['Forum administration'], pun_link($pun_url['admin_index'])),
	$lang_admin['Reports']
);

define('PUN_PAGE_SECTION', 'management');
define('PUN_PAGE', 'admin-reports');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main a-admin">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

<?php echo generate_admin_menu(); ?>
	<div class="b-section b-dataform">
		<div class="c-section c-form">
<?php

$result = $db->query('SELECT r.id, r.post_id, r.topic_id, r.forum_id, r.reported_by, r.created, r.message, t.subject, f.forum_name, u.username AS reporter FROM '.$db->prefix.'reports AS r LEFT JOIN '.$db->prefix.'topics AS t ON r.topic_id=t.id LEFT JOIN '.$db->prefix.'forums AS f ON r.forum_id=f.id LEFT JOIN '.$db->prefix.'users AS u ON r.reported_by=u.id WHERE r.zapped IS NULL ORDER BY created DESC') or error('Unable to fetch report list', __FILE__, __LINE__, $db->error());

if ($db->num_rows($result))
{

?>
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['admin_reports']) ?>?action=zap">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<h2 class="prefix"><span><?php echo $lang_admin['New reports heading'] ?>: </span></h2>
				<p><?php echo $lang_admin['New reports intro'] ?></p>
			</div>
<?php

	while ($cur_report = $db->fetch_assoc($result))
	{
		$reporter = ($cur_report['reporter'] != '') ? '<a href="'.pun_link($pun_url['user'], $cur_report['reported_by']).'">'.htmlspecialchars($cur_report['reporter']).'</a>' : $lang_admin['Deleted user'];
		$forum = ($cur_report['forum_name'] != '') ? '<a href="'.pun_link($pun_url['forum'], $cur_report['forum_id']).'">'.htmlspecialchars($cur_report['forum_name']).'</a>' : $lang_admin['Deleted forum'];
		$topic = ($cur_report['subject'] != '') ? '<a href="'.pun_link($pun_url['topic'], $cur_report['topic_id']).'">'.htmlspecialchars($cur_report['subject']).'</a>' : $lang_admin['Deleted topic'];
		$post = ($cur_report['post_id'] != '') ? str_replace("\n", '<br />', htmlspecialchars($cur_report['message'])) : $lang_admin['Deleted post'];
		$post_id = ($cur_report['post_id'] != '') ? '<a href="'.pun_link($pun_url['post'], $cur_report['post_id']).'">Post #'.$cur_report['post_id'].'</a>' : $lang_admin['Deleted post'];

?>
			<div class="panel subpanel">
				<div class="form-intro">
					<h3><span><?php echo $forum ?>&#160;»&#160;<?php echo $topic ?>&#160;»&#160;<?php echo $post_id ?></span></h3>
				</div>
				<ul class="textset fields">
					<li class="field">
						<strong class="alabel"><?php echo $lang_admin['Reported'] ?></strong><br />
						<span class="input"><?php echo format_time($cur_report['created']).' '.$lang_common['by'].' '.$reporter ?></span>
					</li>
					<li class="field">
						<strong class="alabel"><?php echo $lang_admin['Message'] ?></strong><br />
						<span class="input"><?php echo $post ?></span>
					</li>
				</ul>
				<p class="formsubmit"><input type="submit" class="button" name="zap_id[<?php echo $cur_report['id'] ?>]" value=" <?php echo $lang_admin['Mark read'] ?> " /></p>
			</div>
<?php

	}

?>
			</form>
<?php

}
else
{

?>
			<div class="panel">
				<div class="form-intro">
					<h2><span><?php echo $lang_admin['New reports heading'] ?></span></h2>
				</div>
				<p><?php echo $lang_admin['No new reports'] ?></p>
			</div>
<?php

}

?>
			<div class="divider"><hr /></div>
			<div class="panel">
				<div class="form-intro">
					<h2><span><?php echo $lang_admin['Read reports heading'] ?></span></h2>
				</div>
<?php

$result = $db->query('SELECT r.id, r.post_id, r.topic_id, r.forum_id, r.reported_by, r.created, r.message, r.zapped, r.zapped_by AS zapped_by_id, t.subject, f.forum_name, u.username AS reporter, u2.username AS zapped_by FROM '.$db->prefix.'reports AS r LEFT JOIN '.$db->prefix.'topics AS t ON r.topic_id=t.id LEFT JOIN '.$db->prefix.'forums AS f ON r.forum_id=f.id LEFT JOIN '.$db->prefix.'users AS u ON r.reported_by=u.id LEFT JOIN '.$db->prefix.'users AS u2 ON r.zapped_by=u2.id WHERE r.zapped IS NOT NULL ORDER BY zapped DESC LIMIT 10') or error('Unable to fetch report list', __FILE__, __LINE__, $db->error());

if ($db->num_rows($result))
{

	$i = 1;
	while ($cur_report = $db->fetch_assoc($result))
	{
		$reporter = ($cur_report['reporter'] != '') ? '<a href="'.pun_link($pun_url['user'], $cur_report['reported_by']).'">'.htmlspecialchars($cur_report['reporter']).'</a>' : $lang_admin['Deleted user'];
		$forum = ($cur_report['forum_name'] != '') ? '<a href="'.pun_link($pun_url['forum'], $cur_report['forum_id']).'">'.htmlspecialchars($cur_report['forum_name']).'</a>' : $lang_admin['Deleted forum'];
		$topic = ($cur_report['subject'] != '') ? '<a href="'.pun_link($pun_url['topic'], $cur_report['topic_id']).'">'.htmlspecialchars($cur_report['subject']).'</a>' : $lang_admin['Deleted topic'];
		$post = ($cur_report['post_id'] != '') ? str_replace("\n", '<br />', htmlspecialchars($cur_report['message'])) : $lang_admin['Deleted post'];
		$post_id = ($cur_report['post_id'] != '') ? '<a href="'.pun_link($pun_url['post'], $cur_report['post_id']).'">Post #'.$cur_report['post_id'].'</a>' : $lang_admin['Deleted post'];
		$zapped_by = ($cur_report['zapped_by'] != '') ? '<a href="'.pun_link($pun_url['user'], $cur_report['zapped_by_id']).'">'.htmlspecialchars($cur_report['zapped_by']).'</a>' : $lang_admin['Deleted user'];

		if ($i > 1)
			echo "\t\t\t\t".'<div class="divider"><hr /></div>'."\n";

?>
				<h3><span><?php echo $i.'. '.$forum ?>&#160;»&#160;<?php echo $topic ?>&#160;»&#160;<?php echo $post_id ?></span></h3>
				<ul class="fields textset">
					<li class="field">
						<strong class="alabel"><?php echo $lang_admin['Reported'] ?></strong><br />
						<span class="input"><?php echo format_time($cur_report['created']).' '.$lang_common['by'].' '.$reporter ?></span>
					</li>
					<li class="field">
						<strong class="alabel"><?php echo $lang_admin['Marked read'] ?></strong><br />
						<span class="input"><?php echo format_time($cur_report['zapped']).' '.$lang_common['by'].' '.$zapped_by ?></span>
					</li>
					<li class="field">
						<strong class="alabel"><?php echo $lang_admin['Message'] ?></strong><br />
						<span class="input"><?php echo $post ?></span>
					</li>
				</ul>
<?php

		++$i;
	}
}
else
	echo "\t\t\t\t".'<p>'.$lang_admin['No read reports'].'</p>'."\n";

?>
			</div>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
