<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


if (isset($_GET['action']))
	define('PUN_QUIET_VISIT', 1);

define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';

// Load the login.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/login.php';


$action = isset($_GET['action']) ? $_GET['action'] : null;


// Login
if (isset($_POST['form_sent']) && $action == 'in')
{
	$form_username = trim($_POST['req_username']);
	$form_password = trim($_POST['req_password']);

	$username_sql = ($db_type == 'mysql' || $db_type == 'mysqli') ? 'username=\''.$db->escape($form_username).'\'' : 'LOWER(username)=LOWER(\''.$db->escape($form_username).'\')';

	$result = $db->query('SELECT id, group_id, password, save_pass, salt FROM '.$db->prefix.'users WHERE '.$username_sql) or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
	list($user_id, $group_id, $db_password_hash, $save_pass, $salt) = $db->fetch_row($result);

	$authorized = false;
	if (!empty($db_password_hash))
	{
		$sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
		$form_password_hash = sha1($salt.sha1($form_password));

		if ($sha1_in_db && $db_password_hash == $form_password_hash)
			$authorized = true;
		else if ((!$sha1_in_db && $db_password_hash == md5($form_password)) || ($sha1_in_db && $db_password_hash == sha1($form_password)))
		{
			$authorized = true;

			$salt = random_key(12);
			$form_password_hash = sha1($salt.sha1($form_password));

			// There's an old MD5 hash or an unsalted SHA1 hash in the database, so we replace it
			// with a randomly generated salt and a new, salted SHA1 hash
			$db->query('UPDATE '.$db->prefix.'users SET password=\''.$form_password_hash.'\', salt=\''.$db->escape($salt).'\' WHERE id='.$user_id) or error('Unable to update user password', __FILE__, __LINE__, $db->error());
		}
	}

	if (!$authorized)
		message($lang_login['Wrong user/pass'].' <a href="'.pun_link($pun_url['request_password']).'">'.$lang_login['Forgotten password'].'</a>');

	// Update the status if this is the first time the user logged in
	if ($group_id == PUN_UNVERIFIED)
		$db->query('UPDATE '.$db->prefix.'users SET group_id='.$pun_config['o_default_user_group'].' WHERE id='.$user_id) or error('Unable to update user status', __FILE__, __LINE__, $db->error());

	// Remove this user's guest entry from the online list
	$db->query('DELETE FROM '.$db->prefix.'online WHERE ident=\''.$db->escape(get_remote_address()).'\'') or error('Unable to delete from online list', __FILE__, __LINE__, $db->error());

	$expire = ($save_pass == '1') ? time() + 31536000 : 0;
	pun_setcookie($user_id, $form_password_hash, $expire);

	redirect(htmlspecialchars($_POST['redirect_url']).((substr_count($_POST['redirect_url'],'?') == 1) ? '&' : '?').'login=1', $lang_login['Login redirect']);
}


// Logout
else if ($action == 'out')
{
	if ($pun_user['is_guest'] || !isset($_GET['id']) || $_GET['id'] != $pun_user['id'])
	{
		header('Location: '.pun_link($pun_url['index']));
		exit;
	}

	// Remove user from "users online" list.
	$db->query('DELETE FROM '.$db->prefix.'online WHERE user_id='.$pun_user['id']) or error('Unable to delete from online list', __FILE__, __LINE__, $db->error());

	// Update last_visit (make sure there's something to update it with)
	if (isset($pun_user['logged']))
		$db->query('UPDATE '.$db->prefix.'users SET last_visit='.$pun_user['logged'].' WHERE id='.$pun_user['id']) or error('Unable to update user visit data', __FILE__, __LINE__, $db->error());

	pun_setcookie(1, random_key(8, true), time() + 31536000);

	// Reset tracked topics
	set_tracked_topics(null);

	redirect(pun_link($pun_url['index']), $lang_login['Logout redirect']);
}


// New password
else if ($action == 'forget' || $action == 'forget_2')
{
	if (!$pun_user['is_guest'])
		header('Location: '.pun_link($pun_url['index']));

	if (isset($_POST['form_sent']))
	{
		require PUN_ROOT.'include/email.php';

		// Validate the email-address
		$email = strtolower(trim($_POST['req_email']));
		if (!is_valid_email($email))
			message($lang_common['Invalid e-mail']);

		$result = $db->query('SELECT id, username, salt FROM '.$db->prefix.'users WHERE email=\''.$db->escape($email).'\'') or error('Unable to fetch user info', __FILE__, __LINE__, $db->error());

		if ($db->num_rows($result))
		{
			// Load the "activate password" template
			$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$pun_user['language'].'/mail_templates/activate_password.tpl'));

			// The first row contains the subject
			$first_crlf = strpos($mail_tpl, "\n");
			$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
			$mail_message = trim(substr($mail_tpl, $first_crlf));

			// Do the generic replacements first (they apply to all e-mails sent out here)
			$mail_message = str_replace('<base_url>', $base_url.'/', $mail_message);
			$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $pun_config['o_board_title']), $mail_message);

			// Loop through users we found
			while ($cur_hit = $db->fetch_assoc($result))
			{
				// Generate a new password and a new password activation code
				$new_password = random_key(8, true);
				$new_password_key = random_key(8, true);

				$db->query('UPDATE '.$db->prefix.'users SET activate_string=\''.sha1($cur_hit['salt'].sha1($new_password)).'\', activate_key=\''.$new_password_key.'\' WHERE id='.$cur_hit['id']) or error('Unable to update activation data', __FILE__, __LINE__, $db->error());

				// Do the user specific replacements to the template
				$cur_mail_message = str_replace('<username>', $cur_hit['username'], $mail_message);
				$cur_mail_message = str_replace('<activation_url>', pun_link($pun_url['change_password_key'], array($cur_hit['id'], $new_password_key)), $cur_mail_message);
				$cur_mail_message = str_replace('<new_password>', $new_password, $cur_mail_message);

				pun_mail($email, $mail_subject, $cur_mail_message);
			}

			message(sprintf($lang_login['Forget mail'], '<a href="mailto:'.$pun_config['o_admin_email'].'">'.$pun_config['o_admin_email'].'</a>'));
		}
		else
			message(sprintf($lang_login['No e-mail match'], htmlspecialchars($email)));
	}


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		$lang_login['Request pass']
	);

	define ('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

?>
<div class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form id="afocus" method="post" accept-charset="utf-8" action="<?php echo $base_url ?>/login.php?action=forget_2">
			<div class="panel">
				<input type="hidden" name="form_sent" value="1" />
				<div class="form-warn">
					<p><strong><?php echo $lang_common['Important'] ?></strong> <?php echo $lang_login['Request pass info'] ?></p>
				</div>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<div class="afieldset">
					<p class="field required">
						<label for="fs1f1"><?php echo $lang_common['E-mail address'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input id="fs1f1" type="text" name="req_email" size="50" maxlength="80" /></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="request_pass" value="<?php echo $lang_common['Submit'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


if (!$pun_user['is_guest'])
	header('Location: '.pun_link($pun_url['index']));

// Try to determine if the data in HTTP_REFERER is valid (if not, we redirect to index.php after login)
$redirect_url = (isset($_SERVER['HTTP_REFERER']) && preg_match('#^'.preg_quote($base_url).'/(.*?)\.php#i', $_SERVER['HTTP_REFERER'])) ? htmlspecialchars($_SERVER['HTTP_REFERER']) : pun_link($pun_url['index']);


// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	$lang_common['Login']
);

define('PUN_PAGE', 'login');
require PUN_ROOT.'header.php';

?>
<div class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form id="afocus" method="post" accept-charset="utf-8" action="<?php echo $base_url ?>/login.php?action=in">
			<div class="panel">
				<input type="hidden" name="form_sent" value="1" />
				<input type="hidden" name="redirect_url" value="<?php echo $redirect_url ?>" />
				<div class="form-intro">
					<ul class="optionlist">
						<li><a href="<?php echo pun_link($pun_url['register']) ?>"><?php echo $lang_login['Register now'] ?></a></li>
						<li><a href="<?php echo pun_link($pun_url['request_password']) ?>"><?php echo $lang_login['Forgotten password'] ?></a></li>
					</ul>
				</div>
				<p id="req-msg" class="req-warn"><?php printf($lang_common['Required warn'], '<em class="req-text">'.$lang_common['Required mark'].'<span> '.$lang_common['Required'].'</span></em>') ?></p>
				<div class="afieldset fs-last">
					<p class="field required">
						<label for="fs1f1"><?php echo $lang_common['Username'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="text" id="fs1f1" name="req_username" size="25" maxlength="25" /></span>
					</p>
					<p class="field required">
						<label for="fs1f2"><?php echo $lang_common['Password'] ?> <em class="req-text"><?php echo $lang_common['Required mark'].' <span>'.$lang_common['Required'].'</span>' ?></em></label><br />
						<span class="input"><input type="password" id="fs1f2" name="req_password" size="16" /></span>
					</p>
				</div>
				<p class="formsubmit"><input type="submit" class="button" name="login" value="<?php echo $lang_common['Login'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
