<?php
/***********************************************************************

  Copyright (C) 2002-2007  Rickard Andersson (rickard@punbb.org)

  This file is part of PunBB.

  PunBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


define('PUN_ROOT', './');
require PUN_ROOT.'include/common.php';


// This particular function doesn't require forum-based moderator access. It can be used
// by all moderators and admins.
if (isset($_GET['get_host']))
{
	if (!$pun_user['is_admmod'])
		message($lang_common['No permission']);

	// Is get_host an IP address or a post ID?
	if (@preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $_GET['get_host']))
		$ip = $_GET['get_host'];
	else
	{
		$get_host = intval($_GET['get_host']);
		if ($get_host < 1)
			message($lang_common['Bad request']);

		$result = $db->query('SELECT poster_ip FROM '.$db->prefix.'posts WHERE id='.$get_host) or error('Unable to fetch post IP address', __FILE__, __LINE__, $db->error());
		if (!$db->num_rows($result))
			message($lang_common['Bad request']);

		$ip = $db->result($result);
	}

	message('The IP address is: '.$ip.'<br />The host name is: '.@gethostbyaddr($ip).'<br /><br /><a href="'.pun_link($pun_url['admin_users']).'?show_users='.$ip.'">Show more users for this IP</a>');
}


// All other functions require moderator/admin access
$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
if ($fid < 1)
	message($lang_common['Bad request']);

$result = $db->query('SELECT moderators FROM '.$db->prefix.'forums WHERE id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());

$moderators = $db->result($result);
$mods_array = ($moderators != '') ? unserialize($moderators) : array();

if ($pun_user['g_id'] != PUN_ADMIN && ($pun_user['g_moderator'] != '1' || !array_key_exists($pun_user['username'], $mods_array)))
	message($lang_common['No permission']);

// Load the misc.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/misc.php';


// All other topic moderation features require a topic id in GET
if (isset($_GET['tid']))
{
	$approve = (isset($_GET['approve'])) ? intval($_GET['approve']) : 0;
	$tid = intval($_GET['tid']);
	if ($tid < 1)
		message($lang_common['Bad request']);

	// User pressed the cancel button
	if (isset($_POST['delete_posts_cancel']))
		redirect(pun_link($pun_url['topic'], $tid), $lang_common['Cancel redirect']);

	// Fetch some info about the topic
	$result = $db->query('SELECT t.subject, t.poster, t.posted, t.num_replies, f.id AS forum_id, forum_name FROM '.$db->prefix.'topics AS t INNER JOIN '.$db->prefix.'forums AS f ON f.id=t.forum_id LEFT JOIN '.$db->prefix.'subscriptions AS s ON (t.id=s.topic_id AND s.user_id='.$pun_user['id'].') LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id='.$fid.' AND t.id='.$tid.' AND t.moved_to IS NULL') or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
	if (!$db->num_rows($result))
		message($lang_common['Bad request']);

	$cur_topic = $db->fetch_assoc($result);

	// Approve one or more posts
	if (isset($_POST['approve_posts']))
	{
		$posts = (isset($_POST['posts'])) ? $_POST['posts'] : 0;

		if (empty($posts))
			message($lang_misc['No posts selected']);

		if (preg_match('/[^0-9,]/', implode(',', $posts)))
			message($lang_common['Bad request']);

		// Verify that the post IDs are valid
		$result = $db->query('SELECT 1 FROM '.$db->prefix.'posts WHERE id IN('.implode(',', $posts).') AND topic_id='.$tid) or error('Unable to check posts', __FILE__, __LINE__, $db->error());

		if ($db->num_rows($result) != substr_count($posts, ',') + 1)
			message($lang_common['Bad request']);

		// Approve posts
		foreach ($posts as $post => $approve)
			approve_post($post);

		redirect(pun_link($pun_url['topic'], $tid), $lang_misc['Approve posts redirect']);
	}

	// Delete one or more posts
	if (isset($_POST['delete_posts']) || isset($_POST['delete_posts_comply']))
	{
		$posts = $_POST['posts'];
		if (empty($posts))
			message($lang_misc['No posts selected']);

		if (isset($_POST['delete_posts_comply']))
		{
			if (@preg_match('/[^0-9,]/', $posts))
				message($lang_common['Bad request']);

			// Verify that the post IDs are valid
			$result = $db->query('SELECT 1 FROM '.$db->prefix.'posts WHERE id IN('.$posts.') AND topic_id='.$tid) or error('Unable to check posts', __FILE__, __LINE__, $db->error());

			if ($db->num_rows($result) != substr_count($posts, ',') + 1)
				message($lang_common['Bad request']);

			// Delete the posts
			$db->query('DELETE FROM '.$db->prefix.'posts WHERE id IN('.$posts.')') or error('Unable to delete posts', __FILE__, __LINE__, $db->error());

			if ($db_type != 'mysql' && $db_type != 'mysqli')
			{
				require PUN_ROOT.'include/search_idx.php';
				strip_search_index($posts);
			}

			// Get last_post, last_post_id, and last_poster for the topic after deletion
			$result = $db->query('SELECT id, poster, posted FROM '.$db->prefix.'posts WHERE topic_id='.$tid.' ORDER BY id DESC LIMIT 1') or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
			$last_post = $db->fetch_assoc($result);

			// How many posts did we just delete?
			$num_posts_deleted = substr_count($posts, ',') + 1;

			// Update the topic
			$db->query('UPDATE '.$db->prefix.'topics SET last_post='.$last_post['posted'].', last_post_id='.$last_post['id'].', last_poster=\''.$db->escape($last_post['poster']).'\', num_replies=num_replies-'.$num_posts_deleted.' WHERE id='.$tid) or error('Unable to update topic', __FILE__, __LINE__, $db->error());

			update_forum($fid);

			redirect(pun_link($pun_url['topic'], $tid), $lang_misc['Delete posts redirect']);
		}


		// Setup breadcrumbs
		$pun_page['crumbs'] = array(
			array($pun_config['o_board_title'], pun_link($pun_url['index'])),
			array($cur_topic['forum_name'], pun_link($pun_url['forum'], $fid)),
			array($cur_topic['subject'], pun_link($pun_url['topic'], $tid)),
			$lang_misc['Confirm post delete']
		);

		define('PUN_PAGE', 'dialogue');
		require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<div class="main-head">
		<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>
	</div>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['delete_multiple'], array($fid,$tid)) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<input type="hidden" name="posts" value="<?php echo implode(',', array_keys($posts)) ?>" />
				<p><strong><?php echo $lang_misc['Delete posts comply'] ?></strong></p>
				<p class="formsubmit"><input type="submit" class="button" name="delete_posts_comply" value="<?php echo $lang_misc['Delete'] ?>" /> <input type="submit" class="button" name="delete_posts_cancel" value="<?php echo $lang_common['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

		require PUN_ROOT.'footer.php';
	}


	// Show the delete multiple posts view

	// Load the viewtopic.php language file
	require PUN_ROOT.'lang/'.$pun_user['language'].'/topic.php';

	// Used to disable the Move and Delete buttons if there are no replies to this topic
	$button_status = ($cur_topic['num_replies'] == 0 && $approve == 0) ? ' disabled="disabled"' : '';


	// Determine the post offset (based on $_GET['p'])
	$num_pages = ceil(($cur_topic['num_replies'] + 1) / $pun_user['disp_posts']);

	$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
	$start_from = $pun_user['disp_posts'] * ($p - 1);
	$finish_at = min(($start_from + $pun_user['disp_posts']), ($cur_topic['num_replies'] + 1));

	// Generate paging links
	$main_links = '<div class="pagelinks">'.$lang_common['Pages'].': '.paginate($num_pages, $p, ($approve == 1) ? $pun_url['approve_multiple'] : $pun_url['delete_multiple'], array($fid, $tid)).'</div>';

	// Navigation links for header and page numbering for title/meta description
	$link_url = ($approve == 1) ? $pun_url['approve_multiple'] : $pun_url['delete_multiple'];
	if ($p < $num_pages)
	{
		$pun_page['nav'][] = '<link rel="last" href="'.pun_sublink($link_url, $pun_url['page'], $num_pages, array($fid, $tid)).'" title="'.$lang_common['Page'].' '.$num_pages.'" />';
		$pun_page['nav'][] = '<link rel="next" href="'.pun_sublink($link_url, $pun_url['page'], ($p + 1), array($fid, $tid)).'" title="'.$lang_common['Page'].' '.($p + 1).'" />';
	}
	if ($p > 1)
	{
		$pun_page['nav'][] = '<link rel="prev" href="'.pun_sublink($link_url, $pun_url['page'], ($p - 1), array($fid, $tid)).'" title="'.$lang_common['Page'].' '.($p - 1).'" />';
		$pun_page['nav'][] = '<link rel="first" href="'.pun_link($link_url, array($fid, $tid)).'" title="'.$lang_common['Page'].' 1" />';
		$pun_page['page'] = $p;
	}

	if ($pun_config['o_censoring'] == '1')
		$cur_topic['subject'] = censor_words($cur_topic['subject']);


	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($cur_topic['forum_name'], pun_link($pun_url['forum'], $fid)),
		array($cur_topic['subject'], pun_link($pun_url['topic'], $tid)),
		($approve == 1) ? $lang_topic['Approve posts'] : $lang_topic['Delete posts']
	);

	define('PUN_PAGE', 'modtopic');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main paged">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="main-head">
		<?php echo $main_links."\n" ?>
	</div>

	<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['delete_multiple'], array($fid,$tid)) ?>">
	<div class="b-section b-topic hfeed">
		<h2><span><?php printf($lang_topic['Posts selection'], $start_from + 1, $finish_at, $cur_topic['num_replies'] + 1) ?></span></h2>
		<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
<?php

	require PUN_ROOT.'include/parser.php';

	$post_count = 0;	// Keep track of post numbers

	// Retrieve the posts (and their respective poster)
	$result = $db->query('SELECT u.title, u.num_posts, g.g_id, g.g_user_title, p.id, p.poster, p.poster_id, p.message, p.hide_smilies, p.approved, p.posted, p.edited, p.edited_by FROM '.$db->prefix.'posts AS p INNER JOIN '.$db->prefix.'users AS u ON u.id=p.poster_id INNER JOIN '.$db->prefix.'groups AS g ON g.g_id=u.group_id WHERE p.topic_id='.$tid.' ORDER BY p.id LIMIT '.$start_from.','.$pun_user['disp_posts'], true) or error('Unable to fetch post info', __FILE__, __LINE__, $db->error());

	while ($cur_post = $db->fetch_assoc($result))
	{
		++$post_count;
		$post_options = array();

		// If the poster is a registered user.
		if ($cur_post['poster_id'] > 1)
		{
			$poster = '<a class="url fn" title="'.$lang_topic['Go to profile'].'" href="'.pun_link($pun_url['user'], $cur_post['poster_id']).'">'.htmlspecialchars($cur_post['poster']).'</a>';

			// get_title() requires that an element 'username' be present in the array
			$cur_post['username'] = $cur_post['poster'];
			$user_title = get_title($cur_post);
		}
		// If the poster is a guest (or a user that has been deleted)
		else
		{
			$poster = htmlspecialchars($cur_post['poster']);
			$user_title = $lang_topic['Guest'];
		}

		// Generation post action array (Back to top, checkbox)
		$post_options = array();

		if (($approve == 0 && $start_from + $post_count > 1) || ($approve == 1 && $cur_post['approved'] == 0))
			$post_options[] = '<li class="po-menu po-select checkfield"><span class="alabel"><label for="fld'.$cur_post['id'].'">'.$lang_misc['Select'].'</label></span> <input type="checkbox" id="fld'.$cur_post['id'].'" name="posts['.$cur_post['id'].']" value="1" /></li>';
		else if ($approve == 1)
			$post_options[] = '<li class="po-menu po-nodelete">'.$lang_topic['Cannot approve'].'</li>';
		else
			$post_options[] = '<li class="po-menu po-nodelete">'.$lang_topic['Cannot delete'].'</li>';

		// Perform the main parsing of the message (BBCode, smilies, censor words etc)
		$cur_post['message'] = parse_message($cur_post['message'], $cur_post['hide_smilies']);

?>
		<div class="post<?php if ($post_count % 2 == 0) echo ' altstyle' ?>">
			<div id="p<?php echo $cur_post['id'] ?>" class="posthead">
				<h3><strong><?php echo ($start_from + $post_count) ?></strong> <cite class="author"><?php echo $poster ?></cite> <a class="permalink" rel="bookmark" title="<?php echo $lang_topic['Permalink post'] ?>" href="<?php echo pun_link($pun_url['post'], $cur_post['id']) ?>"><?php echo format_time($cur_post['posted']) ?></a></h3>
			</div>
			<div class="postmain">
				<div class="postbody">
					<ul class="post-author">
						<li class="pa-title"><?php echo $user_title ?></li>
					</ul>
					<div class="post-entry">
						<h4><span class="entry-title"><?php echo ($cur_topic['posted'] == $cur_post['posted']) ? $cur_topic['subject'] : $lang_common['RSS reply'].$cur_topic['subject'] ?></span></h4>
						<div class="entry-content">
							<?php echo $cur_post['message']."\n" ?>
<?php if ($cur_post['edited'] != ''): ?>							<p class="lastedit"><?php printf($lang_topic['Last edited by'], htmlspecialchars($cur_post['edited_by'])) ?> (<abbr class="updated" title="<?php echo date("Y-m-d\Th:i:s\Z", $cur_post['edited']) ?>"><?php echo format_time($cur_post['edited']) ?></abbr>)</p>
<?php endif; ?>						</div>
					</div>
				</div>
			</div>
			<div class="postfoot">
				<ul>
					<?php echo implode("\n\t\t\t\t\t", $post_options)."\n" ?>
				</ul>
			</div>
		</div>
<?php

	}

?>
	</div>

	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<p><span class="mo-users"><?php echo ($approve == 1) ? $lang_misc['Approve marked'] : $lang_misc['Delete marked'] ?></span> <span class="mo-buttom"><input type="submit" class="button" name="<?php echo ($approve == 1) ? 'approve_posts' : 'delete_posts' ?>" value="<?php echo ($approve == 1) ? $lang_misc['Approve'] : $lang_misc['Delete'] ?>"<?php echo $button_status ?> /></span></p>
		</div>
	</div>
	</form>

	<div class="main-foot">
		<?php echo $main_links."\n" ?>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// Move one or more topics
if (isset($_REQUEST['move_topics']) || isset($_POST['move_topics_to']))
{
	if (isset($_POST['move_topics_to']))
	{
		if (@preg_match('/[^0-9,]/', $_POST['topics']))
			message($lang_common['Bad request']);

		$topics = explode(',', $_POST['topics']);
		$move_to_forum = isset($_POST['move_to_forum']) ? intval($_POST['move_to_forum']) : 0;
		if (empty($topics) || $move_to_forum < 1)
			message($lang_common['Bad request']);

		// Verify that the topic IDs are valid
		$result = $db->query('SELECT 1 FROM '.$db->prefix.'topics WHERE id IN('.implode(',',$topics).') AND forum_id='.$fid) or error('Unable to check topics', __FILE__, __LINE__, $db->error());

		if ($db->num_rows($result) != count($topics))
			message($lang_common['Bad request']);

		// Delete any redirect topics if there are any (only if we moved/copied the topic back to where it where it was once moved from)
		$db->query('DELETE FROM '.$db->prefix.'topics WHERE forum_id='.$move_to_forum.' AND moved_to IN('.implode(',', $topics).')') or error('Unable to delete redirect topics', __FILE__, __LINE__, $db->error());

		// Move the topic(s)
		$db->query('UPDATE '.$db->prefix.'topics SET forum_id='.$move_to_forum.' WHERE id IN('.implode(',', $topics).')') or error('Unable to move topics', __FILE__, __LINE__, $db->error());

		// Should we create redirect topics?
		if (isset($_POST['with_redirect']))
		{
			while (list(, $cur_topic) = @each($topics))
			{
				// Fetch info for the redirect topic
				$result = $db->query('SELECT poster, subject, posted, last_post FROM '.$db->prefix.'topics WHERE id='.$cur_topic) or error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
				$moved_to = $db->fetch_assoc($result);

				// Create the redirect topic
				$db->query('INSERT INTO '.$db->prefix.'topics (poster, subject, posted, last_post, moved_to, forum_id) VALUES(\''.$db->escape($moved_to['poster']).'\', \''.$db->escape($moved_to['subject']).'\', '.$moved_to['posted'].', '.$moved_to['last_post'].', '.$cur_topic.', '.$fid.')') or error('Unable to create redirect topic', __FILE__, __LINE__, $db->error());
			}
		}

		update_forum($fid);				// Update the forum FROM which the topic was moved
		update_forum($move_to_forum);	// Update the forum TO which the topic was moved

		$redirect_msg = (count($topics) > 1) ? $lang_misc['Move topics redirect'] : $lang_misc['Move topic redirect'];
		redirect(pun_link($pun_url['forum'], $move_to_forum), $redirect_msg);
	}

	if (isset($_POST['move_topics']))
	{
		$topics = isset($_POST['topics']) ? $_POST['topics'] : array();
		if (empty($topics))
			message($lang_misc['No topics selected']);

		$topics = implode(',', array_keys($topics));
		$action = 'multi';

		// Fetch info about forum
		$result = $db->query('SELECT forum_name FROM '.$db->prefix.'forums WHERE id = '.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
		$forum_name = $db->result($result);
	}
	else
	{
		$topics = intval($_GET['move_topics']);
		if ($topics < 1)
			message($lang_common['Bad request']);

		$action = 'single';

		// Fetch info about topic and forum
		$result = $db->query('SELECT t.subject, f.forum_name FROM '.$db->prefix.'topics AS t INNER JOIN '.$db->prefix.'forums AS f ON f.id = '.$fid.' WHERE t.id = '.$topics.' LIMIT 1') or error('Unable to fetch forum/topic info', __FILE__, __LINE__, $db->error());
		list($subject, $forum_name) = $db->fetch_row($result);
	}

	// Get forums we can move the post into
	$result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name FROM '.$db->prefix.'categories AS c INNER JOIN '.$db->prefix.'forums AS f ON c.id=f.cat_id LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.redirect_url IS NULL AND f.id!='.$fid.' ORDER BY c.disp_position, c.id, f.disp_position') or error('Unable to fetch category/forum list', __FILE__, __LINE__, $db->error());
	$num_forums = $db->num_rows($result);

	if (!$num_forums)
		message($lang_misc['Nowhere to move']);

	$forum_list = array();
	for ($i = 0; $i < $num_forums; ++$i)
		$forum_list[] = $db->fetch_assoc($result);


	// Setup breadcrumbs
	$pun_page['crumbs'][] = array($pun_config['o_board_title'], pun_link($pun_url['index']));
	$pun_page['crumbs'][] = array($forum_name, pun_link($pun_url['forum'], $fid));
	if ($action == 'single')
		$pun_page['crumbs'][] = array($subject, pun_link($pun_url['forum'], $fid));
	else
		$pun_page['crumbs'][] = array($lang_misc['Moderate forum'], pun_link($pun_url['moderate_forum'], $fid));
	$pun_page['crumbs'][] =	($action == 'single') ? $lang_misc['Move topic'] : $lang_misc['Move topics'];

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

?>
<div class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['moderate_forum'], $fid) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<fieldset class="textset" id="fs1">
					<legend><span><?php echo $lang_misc['Move legend'] ?></span></legend>
					<input type="hidden" name="topics" value="<?php echo $topics ?>" />
					<p class="field">
						<label for="fs1f1"><?php echo $lang_misc['Move to'] ?></label><br />
						<span class="input"><select id="fs1f1" name="move_to_forum">
<?php

	$cur_category = 0;
	foreach ($forum_list as $cur_forum)
	{
		if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
		{
			if ($cur_category)
				echo "\t\t\t\t\t\t".'</optgroup>'."\n";

			echo "\t\t\t\t\t\t".'<optgroup label="'.htmlspecialchars($cur_forum['cat_name']).'">'."\n";
			$cur_category = $cur_forum['cid'];
		}

		if ($cur_forum['fid'] != $fid)
			echo "\t\t\t\t\t\t".'<option value="'.$cur_forum['fid'].'">'.htmlspecialchars($cur_forum['forum_name']).'</option>'."\n";
	}

?>
						</optgroup>
						</select></span>
					</p>
					<p class="field">
						<span class="input"><input type="checkbox" id="fs1f2" name="with_redirect" value="1"<?php if ($action == 'single') echo ' checked="checked"' ?> /> <label for="fs1f2"><?php echo ($action == 'single') ? $lang_misc['Leave redirect'] : $lang_misc['Leave redirects'] ?></label></span>
					</p>
				</fieldset>
				<p class="formsubmit"><input type="submit" class="button" name="move_topics_to" value="<?php echo $lang_misc['Move'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// User pressed the cancel button
if (isset($_POST['delete_topics_cancel']))
	redirect(pun_link($pun_url['forum'], $fid), $lang_common['Cancel redirect']);


// Delete one or more topics
else if (isset($_REQUEST['delete_topics']) || isset($_POST['delete_topics_comply']))
{
	$topics = isset($_POST['topics']) ? $_POST['topics'] : array();
	if (empty($topics))
		message($lang_misc['No topics selected']);

	if (isset($_POST['delete_topics_comply']))
	{
		if (@preg_match('/[^0-9,]/', $topics))
			message($lang_common['Bad request']);

		if ($db_type != 'mysql' && $db_type != 'mysqli')
			require PUN_ROOT.'include/search_idx.php';

		// Verify that the topic IDs are valid
		$result = $db->query('SELECT 1 FROM '.$db->prefix.'topics WHERE id IN('.$topics.') AND forum_id='.$fid) or error('Unable to check topics', __FILE__, __LINE__, $db->error());

		if ($db->num_rows($result) != substr_count($topics, ',') + 1)
			message($lang_common['Bad request']);

		// Delete the topics and any redirect topics
		$db->query('DELETE FROM '.$db->prefix.'topics WHERE id IN('.$topics.') OR moved_to IN('.$topics.')') or error('Unable to delete topic', __FILE__, __LINE__, $db->error());

		// Delete any subscriptions
		$db->query('DELETE FROM '.$db->prefix.'subscriptions WHERE topic_id IN('.$topics.')') or error('Unable to delete subscriptions', __FILE__, __LINE__, $db->error());

		// Create a list of the post ID's in this topic and then strip the search index
		$result = $db->query('SELECT id FROM '.$db->prefix.'posts WHERE topic_id IN('.$topics.')') or error('Unable to fetch posts', __FILE__, __LINE__, $db->error());

		$post_ids = '';
		while ($row = $db->fetch_row($result))
			$post_ids .= ($post_ids != '') ? ','.$row[0] : $row[0];

		// We have to check that we actually have a list of post ID's since we could be deleting just a redirect topic
		if ($post_ids != '' && $db_type != 'mysql' && $db_type != 'mysqli')
			strip_search_index($post_ids);

		// Delete posts
		$db->query('DELETE FROM '.$db->prefix.'posts WHERE topic_id IN('.$topics.')') or error('Unable to delete posts', __FILE__, __LINE__, $db->error());

		update_forum($fid);

		redirect(pun_link($pun_url['forum'], $fid), $lang_misc['Delete topics redirect']);
	}


	// Fetch info about forum
	$result = $db->query('SELECT forum_name FROM '.$db->prefix.'forums WHERE id = '.$fid) or error('Unable to fetch forum/topic info', __FILE__, __LINE__, $db->error());
	$forum_name = $db->result($result);

	// Setup breadcrumbs
	$pun_page['crumbs'] = array(
		array($pun_config['o_board_title'], pun_link($pun_url['index'])),
		array($forum_name, pun_link($pun_url['forum'], $fid)),
		array($lang_misc['Moderate forum'], pun_link($pun_url['moderate_forum'], $fid)),
		$lang_misc['Confirm topic delete']
	);

	define('PUN_PAGE', 'dialogue');
	require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="b-section b-dataform">
		<div class="c-section c-form">
			<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['moderate_forum'], $fid) ?>">
			<div class="panel">
				<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
				<input type="hidden" name="topics" value="<?php echo implode(',', array_keys($topics)) ?>" />
				<p><strong><?php echo $lang_misc['Delete topics comply'] ?></strong></p>
				<p class="formsubmit"><input type="submit" class="button" name="delete_topics_comply" value="<?php echo $lang_misc['Delete'] ?>" /> <input type="submit" class="button" name="delete_topics_cancel" value="<?php echo $lang_common['Cancel'] ?>" /></p>
			</div>
			</form>
		</div>
	</div>

</div>
<?php

	require PUN_ROOT.'footer.php';
}


// Open or close one or more topics
else if (isset($_REQUEST['open']) || isset($_REQUEST['close']))
{
	$action = (isset($_REQUEST['open'])) ? 0 : 1;

	// There could be an array of topic ID's in $_POST
	if (isset($_POST['open']) || isset($_POST['close']))
	{
		$topics = isset($_POST['topics']) ? @array_map('intval', @array_keys($_POST['topics'])) : array();
		if (empty($topics))
			message($lang_misc['No topics selected']);

		$db->query('UPDATE '.$db->prefix.'topics SET closed='.$action.' WHERE id IN('.implode(',', $topics).') AND forum_id='.$fid) or error('Unable to close topics', __FILE__, __LINE__, $db->error());

		$redirect_msg = ($action) ? $lang_misc['Close topics redirect'] : $lang_misc['Open topics redirect'];
		redirect(pun_link($pun_url['moderate_forum'], $fid), $redirect_msg);
	}
	// Or just one in $_GET
	else
	{
		$topic_id = ($action) ? intval($_GET['close']) : intval($_GET['open']);
		if ($topic_id < 1)
			message($lang_common['Bad request']);

		$db->query('UPDATE '.$db->prefix.'topics SET closed='.$action.' WHERE id='.$topic_id.' AND forum_id='.$fid) or error('Unable to close topic', __FILE__, __LINE__, $db->error());

		$redirect_msg = ($action) ? $lang_misc['Close topic redirect'] : $lang_misc['Open topic redirect'];
		redirect(pun_link($pun_url['topic'], $topic_id), $redirect_msg);
	}
}


// Stick a topic
else if (isset($_GET['stick']))
{
	$stick = intval($_GET['stick']);
	if ($stick < 1)
		message($lang_common['Bad request']);

	$db->query('UPDATE '.$db->prefix.'topics SET sticky=\'1\' WHERE id='.$stick.' AND forum_id='.$fid) or error('Unable to stick topic', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['topic'], $stick), $lang_misc['Stick topic redirect']);
}


// Unstick a topic
else if (isset($_GET['unstick']))
{
	$unstick = intval($_GET['unstick']);
	if ($unstick < 1)
		message($lang_common['Bad request']);

	$db->query('UPDATE '.$db->prefix.'topics SET sticky=\'0\' WHERE id='.$unstick.' AND forum_id='.$fid) or error('Unable to unstick topic', __FILE__, __LINE__, $db->error());

	redirect(pun_link($pun_url['topic'], $unstick), $lang_misc['Unstick topic redirect']);
}


// No specific forum moderation action was specified in the query string, so we'll display the moderate forum view

// Load the viewforum.php language file
require PUN_ROOT.'lang/'.$pun_user['language'].'/forum.php';

// Fetch some info about the forum
$result = $db->query('SELECT f.forum_name, f.redirect_url, f.num_topics FROM '.$db->prefix.'forums AS f LEFT JOIN '.$db->prefix.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$pun_user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id='.$fid) or error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
	message($lang_common['Bad request']);

$cur_forum = $db->fetch_assoc($result);

// Is this a redirect forum? In that case, abort!
if ($cur_forum['redirect_url'] != '')
	message($lang_common['Bad request']);


// Determine the topic offset (based on $_GET['p'])
$num_pages = ceil($cur_forum['num_topics'] / $pun_user['disp_topics']);

$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $pun_user['disp_topics'] * ($p - 1);
$finish_at = min(($start_from + $pun_user['disp_topics']), ($cur_forum['num_topics']));


// Generate paging links
$main_links = '<div class="pagelinks">'.$lang_common['Pages'].': '.paginate($num_pages, $p, $pun_url['moderate_forum'], $fid).'</div>';

// Navigation links for header and page numbering for title/meta description
if ($p < $num_pages)
{
	$pun_page['nav'][] = '<link rel="last" href="'.pun_sublink($pun_url['moderate_forum'], $pun_url['page'], $num_pages, $fid).'" title="'.$lang_common['Page'].' '.$num_pages.'" />';
	$pun_page['nav'][] = '<link rel="next" href="'.pun_sublink($pun_url['moderate_forum'], $pun_url['page'], ($p + 1), $fid).'" title="'.$lang_common['Page'].' '.($p + 1).'" />';
}
if ($p > 1)
{
	$pun_page['nav'][] = '<link rel="prev" href="'.pun_sublink($pun_url['moderate_forum'], $pun_url['page'], ($p - 1), $fid).'" title="'.$lang_common['Page'].' '.($p - 1).'" />';
	$pun_page['nav'][] = '<link rel="first" href="'.pun_link($pun_url['moderate_forum'], $fid).'" title="'.$lang_common['Page'].' 1" />';
	$pun_page['page'] = $p;
}

// Setup breadcrumbs
$pun_page['crumbs'] = array(
	array($pun_config['o_board_title'], pun_link($pun_url['index'])),
	array($cur_forum['forum_name'], pun_link($pun_url['forum'], $fid)),
	$lang_forum['Moderate forum']
);

define('PUN_PAGE', 'modforum');
require PUN_ROOT.'header.php';

?>
<div id="pun-main1" class="a-section a-main paged">

	<h1 class="main-title"><span><?php echo end($pun_page['crumbs']) ?></span></h1>

	<div class="main-head">
		<?php echo $main_links."\n" ?>
	</div>

	<form method="post" accept-charset="utf-8" action="<?php echo pun_link($pun_url['moderate_forum'], $fid) ?>">
	<div id="forum<?php echo $fid ?>" class="b-section b-forum">
		<h2><span><?php printf($lang_forum['Topics selection'], $start_from + 1, $finish_at, $cur_forum['num_topics']) ?></span></h2>
		<input type="hidden" name="csrf_token" value="<?php echo $pun_user['csrf_token'] ?>" />
		<div class="c-section c-table">
			<table cellspacing="0" summary="<?php echo $lang_forum['Table summary mods'].htmlspecialchars($cur_forum['forum_name']) ?>">
			<thead>
				<tr>
					<th class="tcl" scope="col"><?php echo $lang_common['Topic'] ?></th>
					<th class="tc2" scope="col"><?php echo $lang_common['Replies'] ?></th>
					<th class="tc3" scope="col"><?php echo $lang_forum['Views'] ?></th>
					<th class="tcr" scope="col"><?php echo $lang_common['Last post'] ?></th>
					<th class="tcmod" scope="col"><?php echo $lang_misc['Select'] ?></th>
				</tr>
			</thead>
			<tbody class="hasicon">
<?php

// Select topics
$result = $db->query('SELECT id, poster, subject, posted, last_post, last_post_id, last_poster, num_views, num_replies, closed, sticky, moved_to FROM '.$db->prefix.'topics WHERE forum_id='.$fid.' ORDER BY sticky DESC, last_post DESC LIMIT '.$start_from.', '.$pun_user['disp_topics']) or error('Unable to fetch topic list for forum', __FILE__, __LINE__, $db->error());

// If there are topics in this forum.
if ($db->num_rows($result))
{
	$button_status = '';

	$row_count = $start_from;
	while ($cur_topic = $db->fetch_assoc($result))
	{
		++$row_count;
		$row_style = ($row_count % 2 != 0) ? 'altstyle' : '';
		$icon_type = 'icon';

		if ($cur_topic['moved_to'] == null)
		{
			$last_post = '<a href="'.pun_link($pun_url['post'], $cur_topic['last_post_id']).'">'.format_time($cur_topic['last_post']).'</a> <span class="byuser">'.$lang_common['by'].'&#160;'.htmlspecialchars($cur_topic['last_poster']).'</span>';
			$ghost_topic = false;
		}
		else
		{
			$last_post = '&#160;';
			$ghost_topic = true;
		}

		if ($pun_config['o_censoring'] == '1')
			$cur_topic['subject'] = censor_words($cur_topic['subject']);

		if ($cur_topic['moved_to'] != 0)
			$subject = $lang_forum['Moved'].': <a href="'.pun_link($pun_url['topic'], $cur_topic['moved_to']).'">'.htmlspecialchars($cur_topic['subject']).'</a> <span class="byuser">'.$lang_common['by'].'&#160;'.htmlspecialchars($cur_topic['poster']).'</span>';
		else if ($cur_topic['closed'] == '0')
			$subject = '<a href="'.pun_link($pun_url['topic'], $cur_topic['id']).'">'.htmlspecialchars($cur_topic['subject']).'</a> <span>'.$lang_common['by'].'&#160;'.htmlspecialchars($cur_topic['poster']).'</span>';
		else
		{
			$subject = '<span class="closedtopic">'.$lang_common['Closed'].'</span> <a href="'.pun_link($pun_url['topic'], $cur_topic['id']).'">'.htmlspecialchars($cur_topic['subject']).'</a> <span class="byuser">'.$lang_common['by'].'&#160;'.htmlspecialchars($cur_topic['poster']).'</span>';
			$row_style .= ' iclosed';
		}

		if ($cur_topic['last_post'] > $pun_user['last_visit'] && !$ghost_topic)
		{
			$row_style .= ' inew';
			$icon_type = 'icon inew';
			$subject_new_posts = '<span class="newposts">[&#160;<a href="'.pun_link($pun_url['topic_new_posts'], $cur_topic['id']).'" title="'.$lang_common['New posts info'].'">'.$lang_common['New posts'].'</a>&#160;]</span>';
		}
		else
			$subject_new_posts = null;

		if ($cur_topic['sticky'] == '1')
		{
			$subject = '<span class="stickytopic">'.$lang_forum['Sticky'].'</span> '.$subject;
			$row_style .= ' isticky';
		}

		$num_pages_topic = ceil(($cur_topic['num_replies'] + 1) / $pun_user['disp_posts']);

		if ($num_pages_topic > 1)
		{
			$subject_multipage = '[&#160;'.paginate($num_pages_topic, -1, $pun_url['topic'], $cur_topic['id']).'&#160;]';
			$subject_multipage = '<span class="multipage">'.str_replace('">', '"><span class="acchide">'.$row_count.'&#160;Page&#160;</span>', $subject_multipage).'</span>';
		}
		else
			$subject_multipage = null;

		// Should we show the "New posts" and/or the multipage links?
		if (!empty($subject_new_posts) || !empty($subject_multipage))
		{
			$subject .= '&#160; '.(!empty($subject_new_posts) ? $subject_new_posts : '');
			$subject .= !empty($subject_multipage) ? ' '.$subject_multipage : '';
		}

?>
				<tr<?php if ($row_style != '') echo ' class="'.trim($row_style).'"' ?>>
					<td class="tcl"><div class="<?php echo $icon_type ?>"><!-- --></div><span class="acchide"><?php echo $row_count ?></span> <?php echo $subject ?></td>
					<td class="tc2"><?php echo (!$ghost_topic) ? $cur_topic['num_replies'] : '&#160;' ?></td>
					<td class="tc3"><?php echo (!$ghost_topic) ? $cur_topic['num_views'] : '&#160;' ?></td>
					<td class="tcr"><?php echo $last_post ?></td>
					<td class="tcmod"><input type="checkbox" name="topics[<?php echo $cur_topic['id'] ?>]" value="1" /></td>
				</tr>
<?php

	}
}
else
{
	$button_status = ' disabled="disabled"';

?>
			<tbody>
				<tr>
					<td class="tcl" colspan="5"><?php echo $lang_forum['Empty forum'] ?></td>
				</tr>
<?php

}

?>
			</tbody>
			</table>
		</div>
	</div>
<?php

// Setup moderator control buttons
$main_options[] = '<li id="mo-move" class="mo-button"><input type="submit" class="button" name="move_topics" value="'.$lang_misc['Move'].'"'.$button_status.' /></li>';
$main_options[] = '<li id="mo-delete" class="mo-button"><input type="submit" class="button" name="delete_topics" value="'.$lang_misc['Delete'].'"'.$button_status.' /></li>';
$main_options[] = '<li id="mo-open" class="mo-button"><input type="submit" class="button" name="open" value="'.$lang_misc['Open'].'"'.$button_status.' /></li>';
$main_options[] = '<li id="mo-close" class="mo-button"><input type="submit" class="button" name="close" value="'.$lang_misc['Close'].'"'.$button_status.' /></li>';

?>
	<div class="b-section b-mainoptions">
		<div class="c-section c-any">
			<h2><span><?php echo $lang_forum['Moderate forum'] ?></span></h2>
			<ul class="optionlist">
				<?php echo implode("\n\t\t\t\t", $main_options)."\n"; ?>
			</ul>
		</div>
	</div>
	</form>

	<div class="main-foot">
		<?php echo $main_links."\n" ?>
	</div>

</div>
<?php

require PUN_ROOT.'footer.php';
